<?php
/**
 * webEdition CMS
 *
 * $Rev: 342e215a2edb $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-03-21 11:07 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('modules_voting', '[menu_new]'),
		'icon' => 'fa fa-plus-circle',
	],
	['text' => g_l('modules_voting', '[voting]'),
		'parent' => 'new',
		'cmd' => 'new_voting',
		'perm' => [we_base_perm::VOTING_NEW],
	],
	['text' => g_l('modules_voting', '[group]'),
		'parent' => 'new',
		'cmd' => 'new_voting_group',
		'perm' => [we_base_perm::VOTING_NEW],
	],
	'voting' => [
		'text' => g_l('modules_voting', '[voting]'),
		'icon' => 'fa fa-thumbs-up'
	],
	['text' => g_l('modules_voting', '[menu_save]'),
		'parent' => 'voting',
		'cmd' => 'save_voting',
		'perm' => [we_base_perm::VOTING_EDIT, we_base_perm::VOTING_NEW],
	],
	['text' => g_l('modules_voting', '[menu_delete]'),
		'parent' => 'voting',
		'cmd' => 'delete_voting',
		'perm' => [we_base_perm::VOTING_DELETE],
	],
	['parent' => 'voting',],
	['text' => g_l('modules_voting', '[menu_exit]'),
		'parent' => 'voting',
		'cmd' => 'exit_voting',
	],
];
