<?php
/**
 * webEdition CMS
 * $Rev: 429e43582a0a $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-25 12:34 +0000 $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 */
/*
 * Sets some global variables which are needed
 * for other classes and scripts and defines
 * the __autoload() function
 */

require_once ($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_defines.inc.php');
//essential includes, use these to allow it to be called without we "running"
require_once(WE_INCLUDES_PATH . 'we_db_tools.inc.php');
require_once(WE_INCLUDES_PATH . 'we_classes/base/we_error_handler.class.php');
we_base_errorHandler::start(!isset($GLOBALS['we']['template']['init']));
//include global functions
require_once(WE_INCLUDES_PATH . 'we_global.inc.php');

//Fix some settings
/**
 * Fix the none existing $_SERVER['REQUEST_URI'] on IIS
 */
/* if(!isset($_SERVER['REQUEST_URI']) && !isset($_SERVER['HTTP_REQUEST_URI'])){
  $_SERVER['HTTP_REQUEST_URI'] = getScriptName() . (isset($_SERVER['QUERY_STRING']) ? '?' . $_SERVER['QUERY_STRING'] : '');
  } */
require_once(WE_INCLUDES_PATH . 'we_classes/base/we_base_autoloader.class.php');

if(!defined('DATETIME_INITIALIZED')){// to prevent additional initialization if set somewhere else, i.e in autoload, this also allows later to make that an settings-item
	if(!date_default_timezone_set(@date_default_timezone_get())){
		date_default_timezone_set('Europe/Berlin');
	}
	define('DATETIME_INITIALIZED', 1);
}

if(!isset($GLOBALS['WE_LANGUAGE'])){
	$GLOBALS['WE_LANGUAGE'] = WE_LANGUAGE;
}
if(empty($GLOBALS['we']['Charset']['Backend'])){
	$GLOBALS['we']['Charset']['Backend'] = WE_BACKENDCHARSET;
}

//make we_autoloader the first autoloader
spl_autoload_register('we_base_autoloader::autoload', false, true);
