<?php

/**
 * webEdition CMS
 *
 * $Rev: 9798ee9129dd $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-25 13:07 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifOr extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		$cnt = 0;
		//replace self-close
		$content = preg_replace('/\s*<\?php\s+if\((\(*we_tag\(\'if[^\n]+\))\)\s*{\s*\?><\?php\s*}\s*\?>\n?/', "$1 ||\n", $content, -1, $cnt) . "\n";
		if($cnt === 0){
			return self::parseError('<we:ifOr no condition found', $content);
		}
		//change trailling we:if which must close (
		$content = preg_replace('/\) \|\|\n*\s*<\?php\s+if\((\(*we_tag\(\'if[^\n]+\))\)\s*({)/', ") || \n$1 ))$2", $content, -1, $cnt);
		if($cnt !== 1){
			return self::parseError('<we:ifOr no code for execution found', $content);
		}

		return '<?php if((' . $content;
	}

}
