<?php

/**
 * webEdition CMS
 *
 * $Rev: 7571cdd44178 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-12-18 13:10 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_votingSelect extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$db = $GLOBALS['DB_WE'];

		if(!($GLOBALS['we']['editmode'] && we_tag_voting::$currentVoting && we_tag_voting::$namespace)){
			return '';
		}

		$submitonchange = self::getAttribute('submitonchange', $attribs, false, we_base_request::BOOL);
		$firstentry = self::getAttribute('firstentry', $attribs, '', we_base_request::STRING);
		$reload = self::getAttribute('reload', $attribs, $submitonchange, we_base_request::BOOL);
		$parentid = self::getAttribute('parentid', $attribs, 0, we_base_request::INT);

		$select_name = we_tag_voting::$namespace;

		$newAttribs = ['name' => 'we_' . $GLOBALS['we_doc']->Name . '_txt[' . $select_name . ']'];

		$val = oldHtmlspecialchars($GLOBALS['we_doc']->issetElement($select_name) ? $GLOBALS['we_doc']->getElement($select_name) : 0);

		$newAttribs['onchange'] = ($submitonchange ?
				'we_submitForm();' :
				'_EditorFrame.setEditorIsHot(true)' . ($reload ? (';setScrollTo();top.we_cmd(\'reload_editpage\');') : '') );

		$options = (isset($attribs['firstentry']) ? getHtmlTag('option', ['value' => ''], $firstentry, true) : '');

		$hasOpt = false;
		if($parentid){
			$folders = $db->getAllq('SELECT ID FROM ' . VOTING_TABLE . ' WHERE IsFolder=1 AND ParentID=' . $parentid, true);
			$folders[] = $parentid;
		}

		$db->query('SELECT ID,Text,Path,IsFolder FROM ' . VOTING_TABLE . ' WHERE 1 ' . ($parentid ? ' AND ParentID IN(' . $folders . ')' : '') . we_voting_voting::getOwnersSql() . ' ORDER BY Path');
		while($db->next_record()){
			if($db->f('IsFolder')){
				$options .= ($hasOpt ? '</optgroup>' : '') . '<optgroup label="' . $db->f('Path') . '">';
				$hasOpt = true;
				continue;
			}
			$options .= getHtmlTag('option', ($db->f('ID') == $val ? ['value' => $db->f('ID'), 'selected' => 'selected'] : ['value' => $db->f('ID')]), $db->f('Text'));
		}
		return we_html_element::span(['class' => 'we we_votingSelect'], getHtmlTag('select', $newAttribs, $options . ($hasOpt ? '</optgroup>' : ''), true));
	}

}

function we_tag_votingSelect(array $attribs){
	return we_tag_votingSelect::tag($attribs);
}
