<?php
/**
 * webEdition CMS
 *
 * $Rev: c6229a9152e9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-09 17:19 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
if(!defined('DB_DATABASE')){
	require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/conf/we_conf.inc.php');
}
require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/conf/we_conf_global.inc.php');
include_once ($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_version.php');

define('SERIALIZE_PHP', 'serialize');
define('SERIALIZE_JSON', 'json');
define('WEOBJ_PARAM', 'we_objectID');
define('IS_TINYMCE_4', defined('WYSIWYG_TYPE') ? WYSIWYG_TYPE === 'tinyMCE_beta' : false);

define('WEBEDITION_DIR', '/webEdition/');

define('WE_INCLUDES_DIR', WEBEDITION_DIR . 'we/include/');
define('TEMPLATES_DIR', WEBEDITION_DIR . 'we/templates');
define('TEMP_DIR', WEBEDITION_DIR . 'we/tmp/');
define('CSS_DIR', WEBEDITION_DIR . 'css/');


define('WE_APPS_DIR', WEBEDITION_DIR . 'apps/');
define('SITE_DIR', WEBEDITION_DIR . 'site/');
define('IMAGE_DIR', WEBEDITION_DIR . 'images/');
define('ICON_DIR', IMAGE_DIR . 'icons/');
define('JS_DIR', WEBEDITION_DIR . 'js/');
define('WE_JS_MODULES_DIR', JS_DIR . 'we_modules/');
define('WE_JS_TINYMCE_DIR', JS_DIR . 'wysiwyg/' . (IS_TINYMCE_4 ? 'tinymce_4' : 'tinymce') . '/');
define('BACKUP_DIR', WEBEDITION_DIR . 'we_backup/');
define('VERSION_DIR', WEBEDITION_DIR . 'we/versions/');
define('LIB_DIR', WEBEDITION_DIR . 'lib/');
define('WE_LIB_DIR', LIB_DIR);
define('TINYMCE_SRC_DIR', LIB_DIR . (IS_TINYMCE_4 ? 'tinymce' : 'tinymce_old') . '/');
define('WE_CACHE_DIR', WEBEDITION_DIR . 'we/cache/');

define('EDIT_IMAGE_DIR', IMAGE_DIR . 'edit/');

//all paths
define('BACKUP_PATH', $_SERVER['DOCUMENT_ROOT'] . BACKUP_DIR);
define('JS_PATH', $_SERVER['DOCUMENT_ROOT'] . JS_DIR);
define('TEMPLATES_PATH', $_SERVER['DOCUMENT_ROOT'] . TEMPLATES_DIR);
define('TEMP_PATH', $_SERVER['DOCUMENT_ROOT'] . TEMP_DIR);
define('WEBEDITION_PATH', $_SERVER['DOCUMENT_ROOT'] . WEBEDITION_DIR);
define('WE_APPS_PATH', $_SERVER['DOCUMENT_ROOT'] . WE_APPS_DIR);
define('WE_CACHE_PATH', $_SERVER['DOCUMENT_ROOT'] . WE_CACHE_DIR);
define('WE_INCLUDES_PATH', $_SERVER['DOCUMENT_ROOT'] . WE_INCLUDES_DIR);
define('WE_JS_MODULES_PATH', $_SERVER['DOCUMENT_ROOT'] . WE_JS_MODULES_DIR);
define('WE_LIB_PATH', $_SERVER['DOCUMENT_ROOT'] . LIB_DIR);

//paths without "DIRS"
define('WE_FRAGMENT_PATH', TEMP_PATH . 'fragments');

define('CAPTCHADEF_TABLE', TBL_PREFIX . 'tblCaptchaDef');
define('CAPTCHA_TABLE', TBL_PREFIX . 'tblCaptcha');
//define('CATEGORY_TABLE', TBL_PREFIX . 'tblCategorys');
define('CLEAN_UP_TABLE', TBL_PREFIX . 'tblCleanUp');
define('CONTENT_TABLE', TBL_PREFIX . 'tblContent');
define('DOC_TYPES_TABLE', TBL_PREFIX . 'tblDocTypes');
define('ERROR_LOG_TABLE', TBL_PREFIX . 'tblErrorLog');
define('FAILED_LOGINS_TABLE', TBL_PREFIX . 'tblFailedLogins');
define('FILELINK_TABLE', TBL_PREFIX . 'tblFileLink');
define('FILE_TABLE', TBL_PREFIX . 'tblFile');
define('FORMMAIL_BLOCK_TABLE', TBL_PREFIX . 'tblformmailblock');
define('FORMMAIL_LOG_TABLE', TBL_PREFIX . 'tblformmaillog');
define('HISTORY_TABLE', TBL_PREFIX . 'tblhistory');
define('INDEX_TABLE', TBL_PREFIX . 'tblIndex');
define('LANGLINK_TABLE', TBL_PREFIX . 'tblLangLink');
define('LOCK_TABLE', TBL_PREFIX . 'tblLock');
define('METADATA_TABLE', TBL_PREFIX . 'tblMetadata');
define('METAVALUES_TABLE', TBL_PREFIX . 'tblMetaValues');
define('NOTEPAD_TABLE', TBL_PREFIX . 'tblwidgetnotepad');
define('PREFS_TABLE', TBL_PREFIX . 'tblPrefs');
define('PWDRESET_TABLE', TBL_PREFIX . 'tblPasswordReset');
define('RECIPIENTS_TABLE', TBL_PREFIX . 'tblRecipients');
define('SEARCHRESULT_TABLE', TBL_PREFIX . 'tblSearchResult');
define('SEARCH_TABLE', TBL_PREFIX . 'tblsearchtool');
define('SESSION_TABLE', TBL_PREFIX . 'tblSessions');
define('SETTINGS_TABLE', TBL_PREFIX . 'tblSettings');
define('TEMPLATES_TABLE', TBL_PREFIX . 'tblTemplates');
define('TEMPORARY_DOC_TABLE', TBL_PREFIX . 'tblTemporaryDoc');
define('UPDATE_LOG_TABLE', TBL_PREFIX . 'tblUpdateLog');
define('VALIDATION_SERVICES_TABLE', TBL_PREFIX . 'tblvalidationservices');
define('VERSIONSLOG_TABLE', TBL_PREFIX . 'tblversionslog');
define('VERSIONS_TABLE', TBL_PREFIX . 'tblversions');

//NOTE: you have to register the tables at we.inc!

define('SESSION_NAME', 'WESESSION');
define('WE_DEFAULT_EMAIL', 'mailserver@' . ( empty($_SERVER['SERVER_NAME']) ? 'example.com' : $_SERVER['SERVER_NAME']));
define('WE_LICENSE', 'GPL');
