<?php
/**
 * webEdition CMS
 *
 * $Rev: 36e6181daaf4 $
 * $Author: Lukas Imhof $
 * $Date: 2020-06-05 09:03 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once(WE_INCLUDES_PATH . 'we_tag.inc.php');

we_html_tools::protect();

function reloadElement(we_base_jsCmd $jsCmd, $we_transaction, $we_doc, $id){
	$idArr = explode('_', $id, 2);
	$identifier = array_pop($idArr);
	$uniqid = 'entry_' . $identifier;
	$wholename = $we_doc->getElement('wholename' . $identifier);

	$content = we_html_element::div(['id' => $uniqid, 'class' => 'objectFileElement'], we_html_element::div(['id' => 'f' . $uniqid, 'class' => 'default'], '<table class="defaultfont">' . $we_doc->getFieldHTML($jsCmd, $wholename, $uniqid, $we_transaction) . '	</table>'
	));

	$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);

	return we_gui_OrderContainer::wrapField($jsCmd, 'reload', $uniqid, $content);
}

$cmd = we_base_request::_(we_base_request::CMD, 'we_cmd', '', 0);
$we_transaction = we_base_request::_(we_base_request::TRANSACTION, 'we_transaction', we_base_request::_(we_base_request::TRANSACTION, 'we_cmd', '', 1));
$id = we_base_request::_(we_base_request::STRING, 'we_cmd', false, 2);

$we_doc = new we_object();
$we_dt = $_SESSION['weS']['we_data'][$we_transaction];
$we_doc->we_initSessDat($we_dt);
//
//	---> Setting the Content-Type
//

$jsCmd = new we_base_jsCmd;
$content = '';

switch($cmd){
	case 'object_insert_entry_at_class':
		if($id != false){
			list(, $after) = explode('_', $id, 2);
			$afterid = $id;
		} else {
			$after = false;
			$afterid = false;
		}
		$identifier = str_replace('.', '', uniqid('', true));
		$uniqid = 'entry_' . $identifier;
		$we_doc->addEntryToClass($identifier, $after);

		$cnt = we_html_element::div(['id' => $uniqid, 'class' => 'objectFileElement'], we_html_element::div(['id' => 'f' . $uniqid, 'class' => 'default'], '<table>' . $we_doc->getFieldHTML($jsCmd, $we_doc->getElement('wholename' . $identifier), $uniqid, $we_transaction) . '</table>'));
		$content .= we_gui_OrderContainer::wrapField($jsCmd, 'add', $uniqid, $cnt, $afterid);

		$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);
		break;
	case 'object_change_entry_at_class':
		list(, $identifier) = explode('_', $id, 2);
		$fieldname = $we_doc->getElement('wholename' . $identifier);
		$we_doc->setElement($fieldname . 'default', '');
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;

	case 'object_reload_entry_at_class':
		list(, $identifier) = explode('_', $id, 2);
		$fieldname = $we_doc->getElement('wholename' . $identifier);
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_up_meta_at_class':
		$we_doc->upMetaAtClass(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_down_meta_at_class':
		$we_doc->downMetaAtClass(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_insert_meta_at_class':
		$we_doc->addMetaToClass(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_delete_meta_class':
		$we_doc->removeMetaFromClass(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_del_all_users':
		$we_doc->del_all_users(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_add_user_to_field':
		$we_doc->add_user_to_field(we_base_request::_(we_base_request::INTLISTA, 'we_cmd', '', 3), we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 4));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_del_user_from_field':
		$we_doc->del_user_from_field(we_base_request::_(we_base_request::INT, 'we_cmd', '', 3), we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 4));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_remove_image_at_class';
		$we_doc->remove_image(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_delete_link_at_class':
		$name = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3);
		$we_doc->delElement($name);
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_change_link_at_class':
		$we_doc->changeLink(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3));
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_change_multiobject_at_class':
		$name = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 3);
		while($we_doc->getElement($name . 'count', we_contents_base::ETYPE_TEXT) > 0){
			$we_doc->removeMetaFromClass($name, 0);
		}
		$we_doc->removeMetaFromClass($name, 0);
		$content .= reloadElement($jsCmd, $we_transaction, $we_doc, $id);
		break;
	case 'object_delete_entry_at_class':
		if(isset($id)){
			list(, $identifier) = explode('_', $id, 2);
			$uniqid = 'entry_' . $identifier;
			$we_doc->removeEntryFromClass($identifier);
			$content .= we_gui_OrderContainer::wrapField($jsCmd, 'delete', $uniqid);
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);
		}
		break;
	case 'object_up_entry_at_class':
		if(isset($id)){
			list(, $identifier) = explode('_', $id, 2);
			$uniqid = 'entry_' . $identifier;
			$we_doc->upEntryAtClass($identifier);
			$content .= we_gui_OrderContainer::wrapField($jsCmd, 'up', $uniqid);
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);
		}
		break;
	case 'object_down_entry_at_class':
		if(isset($id)){
			list(, $identifier) = explode('_', $id, 2);
			$uniqid = 'entry_' . $identifier;
			$we_doc->downEntryAtClass($identifier);
			$content .= we_gui_OrderContainer::wrapField($jsCmd, 'down', $uniqid);
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);
		}
		break;
	default:
		break;
}

$charset = $we_doc->getElement('Charset', we_contents_base::ETYPE_TEXT, DEFAULT_CHARSET, true); //	send charset which might be determined in template
//	---> Loading the Stylesheets
$head = '';
if($we_doc->CSS){
	$cssArr = id_to_path(explode(',', $we_doc->CSS), FILE_TABLE, null, true);
	foreach($cssArr as $path){
		$head .= we_html_element::cssLink($path);
	}
}
echo we_html_tools::getHtmlTop('', $charset, 5, $head . we_editor_script::get() . $jsCmd->getCmds(), we_html_element::body([], $content));
