<?php
/**
 * webEdition CMS
 *
 * $Rev: b2e2950d4ecc $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:56 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once(WE_INCLUDES_PATH . 'we_tag.inc.php');
echo we_html_element::docType();
?><html>
	<head><?php
		if(!empty($GLOBALS['we']['editmode'])){
			echo STYLESHEET . JQUERY;
		}

		$charset = $we_doc->getElement('Charset', we_contents_base::ETYPE_TEXT);
		$keyword = $we_doc->getElement(we_contents_root::KEYWORD_FIELD, we_contents_base::ETYPE_TEXT);
		$desc = $we_doc->getElement(we_contents_root::DESCRIPTION_FIELD, we_contents_base::ETYPE_TEXT);
		$title = $we_doc->getElement(we_contents_root::TITLE_FIELD, we_contents_base::ETYPE_TEXT);

		if($charset){
			echo we_html_tools::metaCtCharset($charset);
		}
		if($keyword){
			?>
			<meta name="keywords" content="<?= $keyword ?>">
			<?php
		}
		if($desc){
			?>
			<meta name="description" content="<?= $desc; ?>">
		<?php } ?>
		<title><?= $title ?></title>
		<?php
		if(!empty($GLOBALS['we']['editmode'])){
			echo we_html_element::jsScript(JS_DIR . 'global.js', 'initWE();') .
			we_editor_script::get();
		} else {
			echo we_tag('textarea', ['name' => 'HEAD']);
		}
		?>
	</head>
	<?php if(!empty($GLOBALS['we']['editmode'])){ ?>
		<body style="margin:15px;">
			<form name="we_form" method="post"><?php
				echo we_contents_base::hiddenTrans();
				$foo = '<html><head>' .
					($keyword ? we_html_element::meta(['name' => 'keywords', 'content' => $keyword]) : '') .
					($charset ? we_html_tools::metaCtCharset($charset) : '') .
					($desc ? we_html_element::meta(['name' => 'description', 'content' => $desc]) : '');

				$foo = '<pre class="defaultfont">' . oldHtmlspecialchars($foo . we_html_element::title($title)) . '
</pre>
	' . we_tag('textarea', ['name' => 'HEAD', 'rows' => 8, 'cols' => 80, 'wrap' => 'virtual', 'style' => 'width: 600px;']) . '<br/>
<pre class="defaultfont">	&lt;/head&gt;
	&lt;body ' . we_tag('input', ['type' => 'text', 'size' => 60, 'name' => 'BODYTAG', 'style' => 'width: 480px;']) . '&gt;</pre>
' . we_tag('textarea', ['name' => 'BODY', 'rows' => 15, 'cols' => 80, 'wrap' => 'virtual', 'style' => 'width: 600px;']) . '
<pre class="defaultfont">	&lt;/body&gt;
&lt;/html&gt;</pre>';
				echo we_html_tools::messageBox(667, 650, $foo) .
				we_html_element::hidden("we_complete_request", 1);
				?>
			</form>
		</body>
	<?php } else { ?>
		<body <?= we_tag('input', ['name' => 'BODYTAG']); ?>>
			<?= we_tag('textarea', ['name' => 'BODY'], ''); ?>
		</body>
	<?php } ?>
</html>